%global eclipse_base     %{_libdir}/eclipse
%global eclipse_dropin   %{_datadir}/eclipse/dropins

%global tag DTP_1_10_1_Release_201209080500
# Match the context qualifier with the upstream p2 repo
# 
# eclipse -consolelog -nosplash -application org.eclipse.equinox.p2.director \
#  -repository http://download.eclipse.org/datatools/updates -list | \
#  grep org.eclipse.datatools.sdk.feature.feature.group | grep %%{version} | \
#  sed "s/org.eclipse.datatools.sdk.feature.feature.group=//" | \
#  sed "s/%%{version}.//" | \
#  sed "s/-.*//"

# For 1.10 M6, use this zip
# http://www.eclipse.org/downloads/download.php?file=/datatools/downloads/drops/N_DTP_1.10/dtp-p2repo-1.10.0M6-201203160500.zip
# and get the IU list as above
%global qualifier v201209080500

Name:      eclipse-dtp
Version:   1.10.1
Release:   1%{?dist}
Summary:   Eclipse Data Tools Platform
Group:     System Environment/Libraries
License:   EPL
URL:       http://www.eclipse.org/datatools/

# get-dtp.sh will download all these tarballs
Source0:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.build.git/snapshot/org.eclipse.datatools.build-%{tag}.tar.bz2
Source1:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.connectivity.git/snapshot/org.eclipse.datatools.connectivity-%{tag}.tar.bz2
Source2:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.doc.git/snapshot/org.eclipse.datatools.doc-%{tag}.tar.bz2
Source3:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.general.git/snapshot/org.eclipse.datatools.enablement.general-%{tag}.tar.bz2
Source4:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.hsqldb.git/snapshot/org.eclipse.datatools.enablement.hsqldb-%{tag}.tar.bz2
Source5:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.ibm.git/snapshot/org.eclipse.datatools.enablement.ibm-%{tag}.tar.bz2
Source6:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.ingres.git/snapshot/org.eclipse.datatools.enablement.ingres-%{tag}.tar.bz2
Source7:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.msft.git/snapshot/org.eclipse.datatools.enablement.msft-%{tag}.tar.bz2
Source8:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.mysql.git/snapshot/org.eclipse.datatools.enablement.mysql-%{tag}.tar.bz2
Source9:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.oda.git/snapshot/org.eclipse.datatools.enablement.oda-%{tag}.tar.bz2
Source10:  http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.oracle.git/snapshot/org.eclipse.datatools.enablement.oracle-%{tag}.tar.bz2
Source11:  http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.postgresql.git/snapshot/org.eclipse.datatools.enablement.postgresql-%{tag}.tar.bz2
Source12:  http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.sap.git/snapshot/org.eclipse.datatools.enablement.sap-%{tag}.tar.bz2
Source13:  http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.sqlite.git/snapshot/org.eclipse.datatools.enablement.sqlite-%{tag}.tar.bz2
Source14:  http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.sybase.git/snapshot/org.eclipse.datatools.enablement.sybase-%{tag}.tar.bz2
Source15:  http://git.eclipse.org/c/datatools/org.eclipse.datatools.incubator.git/snapshot/org.eclipse.datatools.incubator-%{tag}.tar.bz2
Source16:  http://git.eclipse.org/c/datatools/org.eclipse.datatools.modelbase.git/snapshot/org.eclipse.datatools.modelbase-%{tag}.tar.bz2
Source17:  http://git.eclipse.org/c/datatools/org.eclipse.datatools.sqltools.git/snapshot/org.eclipse.datatools.sqltools-%{tag}.tar.bz2
Source18:  get-dtp.sh

# Build with Java 7 SQL interfaces
Patch0:    %{name}-java7.patch

# remove duplicate plugin from sqltools features (it's actually built in the
# connectivity feature)
Patch1:    %{name}-remove-duplicate-plugin.patch

# Build against newer Lucene
Patch2:    %{name}-useluceneCoreUpTo30.patch
Patch3:    %{name}-anyluceneCoreinsqldevtoolsResultsfeature.patch
Patch4:    %{name}-use-TopDocs-instead-of-Hits.patch
Patch5:    %{name}-use-ANALYZED-instead-of-TOKENIZED.patch
Patch6:    %{name}-enable-newer-javax.wsdl.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if 0%{?rhel} >= 6
ExclusiveArch: %{ix86} x86_64
%else
BuildArch:        noarch
%endif 

BuildRequires:    java-devel >= 1:1.7.0
BuildRequires:    jpackage-utils
BuildRequires:    eclipse-pde >= 1:4.2.0-0.4
BuildRequires:    eclipse-emf
BuildRequires:    eclipse-gef >= 3.6.1
BuildRequires:    wsdl4j >= 1.5.2-6.6
BuildRequires:    xerces-j2 >= 2.7.1-10.3
BuildRequires:    xml-commons-resolver >= 1.1-2.15
BuildRequires:    xalan-j2 >= 2.7.0-7.5
BuildRequires:    xml-commons-apis >= 1.3.04-1.4
BuildRequires:    lpg-java-compat = 1.1.0

Requires:         java >= 1:1.7.0
Requires:         jpackage-utils
Requires:         eclipse-platform >= 1:3.4.2
Requires:         eclipse-emf
Requires:         eclipse-gef
Requires:         wsdl4j >= 1.5.2-6.6
Requires:         xerces-j2 >= 2.7.1-10.3
Requires:         xml-commons-resolver >= 1.1-2.15
Requires:         xalan-j2 >= 2.7.0-7.5
Requires:         xml-commons-apis >= 1.3.04-1.4
Requires:         lpg-java-compat = 1.1.0

%description
The Eclipse Data Tools Platform provides extensible frameworks and exemplary 
tools, enabling a diverse set of plug-in offerings specific to particular 
data-centric technologies and supported by the DTP ecosystem.

%prep
%setup -q -c dtp-%{version} -a 1 -a 2 -a 3 -a 4 -a 5 -a 6 -a 7 -a 8 -a 9 -a 10 -a 11 -a 12 -a 13 -a 14 -a 15 -a 16 -a 17

# apply patches
pushd org.eclipse.datatools.connectivity-%{tag}/plugins/org.eclipse.datatools.connectivity.sqm.core
%patch0 -p3
popd
pushd org.eclipse.datatools.build-%{tag}
%patch1 -p1
popd
pushd org.eclipse.datatools.sqltools-%{tag}/plugins/org.eclipse.datatools.sqltools.result
%patch2

# FIXME: disable porting to lucene 3.5 until
#         patch is reviewed upstream.
#%patch4 -p3
#%patch5 -p3

popd
pushd org.eclipse.datatools.build-%{tag}/features/org.eclipse.datatools.sqldevtools.results.feature
%patch3
popd
pushd org.eclipse.datatools.enablement.oda-%{tag}
%patch6 -p1
popd

pushd org.eclipse.datatools.build-%{tag}/features
# Use any xerces version
sed -i -e "s|2.9.0.qualifier|0.0.0|g" \
  org.eclipse.datatools.enablement.oda.feature/feature.xml
popd

pushd org.eclipse.datatools.doc-%{tag}/packaged_jars
rm -rf *.jar
popd

# make sure upstream hasn't snuck in any jars we don't know about
JARS=""
for j in `find -name "*.jar"`; do
  if [ ! -L $j ]; then
    JARS="$JARS $j"
  fi
done
if [ ! -z "$JARS" ]; then
   echo "These jars should be deleted and symlinked to system jars: $JARS"
   # There are some test JARs that can remain
   #exit 1
fi

mkdir orbitDeps
pushd orbitDeps
ln -s %{_javadir}/lucene.jar lucene.jar
ln -s %{_javadir}/xerces-j2.jar org.apache.xerces_2.9.0.jar
ln -s %{_javadir}/xalan-j2-serializer.jar org.apache.xml.serializer_2.7.1.jar
ln -s %{_javadir}/xml-commons-resolver.jar org.apache.xml.resolver_1.2.0.jar
ln -s %{_javadir}/xml-commons-apis.jar javax.xml_1.3.4.jar
ln -s %{_javadir}/wsdl4j.jar javax.wsdl_1.5.1.jar
ln -s %{_javadir}/lpgjavaruntime.jar net.sourceforge.lpg.lpgjavaruntime_1.1.0.jar
popd

%build
OPTIONS="-DjavacTarget=1.5 -DjavacSource=1.5 -DforceContextQualifier=%{qualifier}"

# build all features except for documentation and SDK features TODO: build everything
eclipse-pdebuild -f org.eclipse.datatools.modelbase.feature \
  -d "emf gef" -o `pwd`/orbitDeps -a "$OPTIONS"
eclipse-pdebuild -f org.eclipse.datatools.connectivity.feature \
  -d "emf gef" -o `pwd`/orbitDeps -a "$OPTIONS"
eclipse-pdebuild -f org.eclipse.datatools.sqldevtools.feature \
  -d "emf gef" -o `pwd`/orbitDeps -a "$OPTIONS"
eclipse-pdebuild -f org.eclipse.datatools.enablement.feature \
  -d "emf gef" -o `pwd`/orbitDeps -a "$OPTIONS"

%install
rm -rf %{buildroot}
install -d -m 755 %{buildroot}%{eclipse_dropin}
unzip -q -d %{buildroot}%{eclipse_dropin}/dtp-modelbase build/rpmBuild/org.eclipse.datatools.modelbase.feature.zip
unzip -q -d %{buildroot}%{eclipse_dropin}/dtp-connectivity build/rpmBuild/org.eclipse.datatools.connectivity.feature.zip
unzip -q -d %{buildroot}%{eclipse_dropin}/dtp-sqldevtools build/rpmBuild/org.eclipse.datatools.sqldevtools.feature.zip
unzip -q -d %{buildroot}%{eclipse_dropin}/dtp-enablement build/rpmBuild/org.eclipse.datatools.enablement.feature.zip

# use system bundles
pushd %{buildroot}%{eclipse_dropin}/dtp-enablement/eclipse/plugins
rm org.apache.xerces_*.jar
rm org.apache.xml.serializer_*.jar
ln -s ../../../../../java/xalan-j2-serializer.jar org.apache.xml.serializer_2.7.1.jar
rm org.apache.xml.resolver_*.jar
ln -s ../../../../../java/xml-commons-resolver.jar org.apache.xml.resolver_1.2.0.jar
rm javax.xml_*.jar
rm javax.wsdl_*.jar
ln -s ../../../../../java/wsdl4j.jar javax.wsdl_1.5.1.jar
popd
pushd %{buildroot}%{eclipse_dropin}/dtp-sqldevtools/eclipse/plugins
rm net.sourceforge.lpg.lpgjavaruntime_*.jar
ln -s ../../../../../java/lpgjavaruntime.jar net.sourceforge.lpg.lpgjavaruntime_1.1.0.jar
rm org.apache.lucene.core_*.jar
popd

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{eclipse_dropin}/dtp-modelbase
%{eclipse_dropin}/dtp-connectivity
%{eclipse_dropin}/dtp-sqldevtools
%{eclipse_dropin}/dtp-enablement
%doc org.eclipse.datatools.build-%{tag}/features/org.eclipse.datatools.sdk-all.feature/rootfiles/*

%changelog
* Thu Oct 4 2012 Krzysztof Daniel <kdaniel@redhat.com> 1.10.1-1
- Update to 1.10.1

* Tue Jul 27 2012 Sami Wagiaalla <swagiaal@redhat.com> 1.10-4
- Remove correct version of copied lucene jar.

* Tue Jul 26 2012 Sami Wagiaalla <swagiaal@redhat.com> 1.10-3
- Remove copied lucene jar.

* Thu Jul 19 2012 Sami Wagiaalla <swagiaal@redhat.com> 1.10-2
- Disable porting to lucene 3.5 patches.

* Tue Jul 17 2012 Sami Wagiaalla <swagiaal@redhat.com> 1.10-1
- Update to 1.10.
- Port dtp to lucene 3.5.

* Mon Apr 9 2012 Andrew Overholt <overholt@redhat.com> 1.10-0.1.M6
- Update to 1.10 M6.

* Fri Dec 2 2011 Andrew Overholt <overholt@redhat.com> 1.9.1-3
- Fix ExclusiveArch/noarch.

* Fri Dec 2 2011 Andrew Overholt <overholt@redhat.com> 1.9.1-2
- Update patch to build against Java 7 SQL interfaces.
- Bump Java build and runtime requirements accordingly.

* Wed Nov 30 2011 Andrew Overholt <overholt@redhat.com> 1.9.1-1
- Update to 1.9.1.

* Mon Nov 28 2011 Andrew Overholt <overholt@redhat.com> 1.9.0-3
- Add ExclusiveArch for RHEL.
- Use lucene.core instead of plain lucene.

* Mon Jul 11 2011 Andrew Overholt <overholt@redhat.com> 1.9.0-2
- Add patches to compile against newer lucene.

* Wed Jul 6 2011 Andrew Overholt <overholt@redhat.com> 1.9.0-1
- Update to 1.9.0.

* Fri Mar 18 2011 Mat Booth <fedora@matbooth.co.uk> 1.8.2-1
- Update to 1.8.2.

* Thu Feb 10 2011 Alexander Kurtakov <akurtako@redhat.com> 1.8.1-3
- Fix build with xerces 2.11.0.
- Update qualifier to the recent one.

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.8.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Tue Nov 23 2010 Chris Aniszczyk <zx@redhat.com> 1.8.1-1
- Update to 1.8.1 (Helios SR1).

* Tue Jul 20 2010 Andrew Overholt <overholt@redhat.com> 1.8.0-1
- Update to 1.8.0 (Helios).
- Clarify get-dtp.sh a bit.
- Re-generate Java 6 patch.

* Wed Mar 3 2010 Alexander Kurtakov <akurtako@redhat.com> 1.7.2-1
- Update to 1.7.2.

* Tue Oct 27 2009 Alexander Kurtakov <akurtako@redhat.com> 1.7.1-1
- Update to 1.7.1.

* Sat Sep 19 2009 Mat Booth <fedora@matbooth.co.uk> - 1.7.0-5
- Re-enable jar repacking now that RHBZ #461854 has been resolved.

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.7.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue Jul 14 2009 Mat Booth <fedora@matbooth.co.uk> 1.7.0-3
- Disable jar repacking because of a bug in redhat-rpm-config, see #461854.
- Update dependency on wsdl4j.

* Sun Jul 05 2009 Mat Booth <fedora@matbooth.co.uk> 1.7.0-2
- Build all features.
- Add dependency on LPG.

* Thu Jul 02 2009 Mat Booth <fedora@matbooth.co.uk> 1.7.0-1
- Update to 1.7.0 final release (Galileo).
- Get map files from CVS instead of maintaining our own.
- Require Eclipse 3.4.2.

* Wed May 27 2009 Alexander Kurtakov <akurtako@redhat.com> 1.7.0-0.1.RC2
- Update to 1.7.0 RC2.
- Use %%global.

* Mon Mar 23 2009 Alexander Kurtakov <akurtako@redhat.com> 1.6.2-2
- Rebuild to not ship p2 context.xml.

* Fri Feb 27 2009 Alexander Kurtakov <akurtako@redhat.com> 1.6.2-1
- Update to 1.6.2.

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.6.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Fri Feb 13 2009 Alexander Kurtakov <akurtako@redhat.com> 1.6.1-3
- Add patch to fix build with java 6.

* Wed Feb 11 2009 Alexander Kurtakov <akurtako@redhat.com> 1.6.1-2
- Set rt.jar to the build.
- Do not own dropins folder.
- Added comments about builded features and fixes.

* Wed Feb 9 2009 Alexander Kurtakov <akurtako@redhat.com> 1.6.1-1
- Initial package.
